var $ = jQuery;
$(function() { 
	var tdClass = new Array();;
	var isFocusCell = false; // Стоит фокус или нет
	var oldRateCell;
	
	// Ставим подстветку
	function tdFocus(thisObj, thisClass){
		tdClass = thisClass.split(' ');
		oldRateCell = thisObj.children('input').val();
		$('.'+tdClass[0]).each(function(){
			$(this).css('background-color', '#f1f1f1');
		});
		$('.'+tdClass[1]).each(function(){
			$(this).css('background-color', '#f1f1f1');
		});
	}
	
	// Убираем подстветку
	function tdUnFocus(thisObj){
		oldRateCell = undefined;
		$('.'+tdClass[0]).each(function(){
			$(this).css('background-color', '#fff');
		});
		$('.'+tdClass[1]).each(function(){
			$(this).css('background-color', '#fff');
		});
	}
	
	function Rating(thisObj, OldRate) {
		// Здесь thisObj - div rateCell, а не input, который является дочкой
		thisObj.children('input').attr("disabled", true);
		// Получаем подмодуль
		var reg = /col_\d+/;
		var col = ''+reg.exec(thisObj.attr('class'));
		//SubmoduleID = $('.RatingTableSubmodulesHead .'+col+':first').attr('id');
		SubmoduleID = $('.RatingTableSubmodulesHeadMaxRate .'+col+':first').attr('id');

		// Получаем студента
		var reg = /row_\d+/;
		var row = ''+reg.exec(thisObj.attr('class'));
		StudentID = $('.'+row+':first').attr('id');
		
		if (thisObj.children('input').val() != '')
			var NewRate = thisObj.children('input').val();
		else var NewRate = 0;
		var MaxRate = $('.RatingTableSubmodulesHeadMaxRate .'+col+':first').children('input').val();

		if (parseInt(NewRate) <= parseInt(MaxRate)) 
		{
			$.post(
				URLdir + 'handler/rating/setRate',
				{	
					'student': StudentID,
					'submodule': SubmoduleID,
					'rate': NewRate
				},
				function(data){
					data = $.parseJSON(data);
					if(data.success === true) {
						thisObj.siblings('.RateResult').text(parseInt(thisObj.siblings('.RateResult').text()) - parseInt(OldRate) + parseInt(NewRate));
						EventInspector_ShowMsg('Балл добавлен/изменен', 'success');
					}
					else EventInspector_ShowMsg('Не удалось добавить/изменить балл', 'error');
					thisObj.children('input').removeAttr('disabled');
				}
			);
		} 
		else {
			if (parseInt(OldRate) <= parseInt(MaxRate))
				thisObj.children('input').val(OldRate);
			else
				thisObj.children('input').val('0');
			EventInspector_ShowMsg('Текущий балл превышает максимальный для данного модуля', 'error');
			thisObj.children('input').removeAttr('disabled');
		}
	}
	
	$('.rateCell').mouseenter(function(){
		if (isFocusCell == false)
			tdFocus($(this), $(this).attr('class'));
	});
	
	$('.rateCell').mouseleave(function(){
		if (isFocusCell == false)
			tdUnFocus($(this));
	});
	
	var OldRate = 0;
	$('.rateCell').focusin(function(){
		isFocusCell = true;
		tdFocus($(this), $(this).attr('class'));
		if ($(this).children('input').val() != '')
			OldRate = $(this).children('input').val();
		else OldRate = 0;
	});
	
	$('.rateCell').focusout(function(){
		isFocusCell = false;
		if ($(this).children('input').val() != '')
			var NewRate = $(this).children('input').val();
		else var NewRate = 0;
		if (NewRate != OldRate)
			Rating($(this), OldRate);
		tdUnFocus($(this));
	});
	
	$('.rateCell').keyup(function(e){
		thisObj = $(this);
		
		// Получаем подмодуль
		var reg = /col_\d+/;
		var col = ''+reg.exec(thisObj.attr('class'));
		col = col.replace('col_', '');
		col = parseInt(col);
		
		// Получаем студента
		var reg = /row_\d+/;
		var row = ''+reg.exec(thisObj.attr('class'));
		row = row.replace('row_', '');
		row = parseInt(row);
		
		// При нажатие Enter (переход к оцениванию след. студента, т.е. ниже)
		if(e.keyCode==13)
		{	
			row = row + 1;
			$('.row_' + row + '.col_' + col + '.rateCell').children('input').focus();
		}
		// Стрелка вверх
		if(e.keyCode==38)
		{
			row = row - 1;
			$('.row_' + row + '.col_' + col + '.rateCell').children('input').focus();
		}
		
		// Стрелка вправо
		if(e.keyCode==39)
		{
			col = col + 1;
			$('.row_' + row + '.col_' + col + '.rateCell').children('input').focus();
		}
		
		// Стрелка вниз
		if(e.keyCode==40)
		{
			row = row + 1;
			$('.row_' + row + '.col_' + col + '.rateCell').children('input').focus();
		}
		
		// Стрелка влево
		if(e.keyCode==37)
		{
			col = col - 1;
			$('.row_' + row + '.col_' + col + '.rateCell').children('input').focus();
		}
	});
	
	$('.rateCell input').focusin(function(){
		$(this).select();
	});
	
	// При нажатие на элемент rateCell дочерный input получает фокус
	$('.rateCell ').click(function(){
		$(this).children('input').focus();
	} );
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$('.rateCell').children('input').keydown(function(event) {
		KeyDownOnlyNumber(event);
    });
	
	/*
    $(window).scroll(function () {
        if ($(this).scrollTop() > 160) {
			$('.HideStudentsRateHeadTableWrapper').show();
        } else {
			$('.HideStudentsRateHeadTableWrapper').hide();
        }
    });
	*/
	
});
